require 'faraday'
require 'json'
require 'restonomic/customer_group'
require 'restonomic/customer'
require 'restonomic/layout'
require 'restonomic/product'
require 'restonomic/version'

module Restonomic
  class API
    attr_reader :conn

    def initialize(options = {})
      options = {
        headers: {
          appId: options[:appId],
          accessId: options[:accessId]
        }
      }
      @conn ||= connection options
    end

    def call(path, _params = {})
      response = conn.get path
      JSON.parse response.body
    end

    def method_missing klass
      klass = eval("#{klass.to_s.split('_').collect!{ |v| v.capitalize! }.join}.new(self)")
    end

    private

    def connection(options)
      Faraday.new('https://restapi.e-conomic.com/', options) do |faraday|
        faraday.adapter Faraday.default_adapter
        # faraday.response :logger
      end
    end
  end
end
